/*****************************************************************/
/*
/* 1btoraw.c copyright (c) 1994 Clemson University, all rights reserved.
/*
/* 1BTORAW.C - Main calling program.
/*  Default usage: 
/*   1btoraw <input_file> 
/*  Options:  
/*   -o specify output file combinations
/*   -w convert 10 bits to 16 bits not 8
/*   -h displays this options list.
/*
/* $Log: 1btoraw.c,v $
 * Revision 1.1  1995/06/07  13:31:30  rheil
 * Initial revision
 *
/*
/******************************************************************/
/* UNIX INCLUDE FILES */
#include <stdio.h>
 
/* 1b_to_raw INCLUDE FILES */
#include "macros.h"
#include "types.h"
#include "hrpt.h"

/* GLOBAL VARIABLES */
static char _1btoraw[] = "$Header: /projects/level1b/create.1bl/C/RCS/1btoraw.c,v 1.1 1995/06/07 13:31:30 rheil Exp $";
extern int4 optind;       /*** used with getopt for argument processing ***/
extern byte *optarg;      /*** used with getopt for argument processing ***/

/* FUNCTIONS CALLED */
/* void gen_output(hrpt_header, FILE, FILE, runrec, outrec, rmc)
/******************************************************************/

main(argc, argv)
int4 argc;
byte **argv;
{
     onebrec data;
     int4    i, j, k;
     char    *strptr,temp_n[20];

     bzero(&data,sizeof(data));

     /* Parse options from command line and open files */
     while (( i = getopt (argc, argv, "i:o:c:wh")) != EOF)
          switch (i)
          {
          case 'i':
               if(data.inf++)
                    data.er++;
               strcpy(data.oneb_n,optarg);
               if((data.oneb_f = fopen(optarg,"r")) == NULL)
               {
                    data.er++;
                    fprintf(stderr,"***Error: cannot open file: %s\n",optarg);
               }
               break;
          case 'o':
               if(data.outf++)
                    data.er++;
               strcpy(temp_n,optarg);
               break;
          case 'c':
               if(data.ch == 9)
               {
                    data.er++;
                    fprintf(stderr,"***Error: too many output files: 10 max");
               }
               else
               {
                    strptr = optarg;
                    i = (1+strlen(strptr)) / 2;
                    strcpy(data.suffix[data.ch],".");
                    k = atoi(strptr)-1;
                    for(j = 0;j<i;j++)
                    {
                         strncat(data.suffix[data.ch],strptr,1);
                         k = atoi(strptr)-1;
                         if(k < 0 || k > 5)
                         {
                             data.er++;
                             fprintf(stderr,"***Error: -c (%d) out of range",k);
                         }
                         else
                             data.raw_i[data.ch][k] = 1;
                         strptr +=2;
                    }
               }
               data.ch++;
               break;
          case 'w':
               data.w = 1;
               break;
          case 'h':
               fprintf(stderr,"\nUsage: %s -i <input_file_name>",argv[0]);
               fprintf(stderr," [-w 10 bits to 16 (default is 8)]\n");
               fprintf(stderr,"       [-o <output_file_prefix>]");
               fprintf(stderr," [-c channels to extract (MAX 10 sets]\n\n");
               exit(1);
               break;
          }

     if(!data.ch)
     {
          strcpy(data.raw_n[0],data.oneb_n);
          strcat(data.raw_n[0],".12345");
          for(i = 0; i<5; i++)
          data.raw_i[0][i] = 1;
          if((data.raw_f[0] = fopen(data.raw_n[0],"w")) == NULL)
          {
               data.er++;
               fprintf(stderr,"***Error: cannot open file: %s\n",data.raw_n[0]);
          }
          data.ch++;
     }
     else 
     {
          for(i = 0; i<data.ch; i++)
          {
               strcpy(data.raw_n[i],temp_n);
               strcat(data.raw_n[i],data.suffix[i]);
               if((data.raw_f[i] = fopen(data.raw_n[i],"w")) == NULL)
               {
                    data.er++;
                    fprintf(stderr,"***Error: cannot open %s\n",data.raw_n[i]);
               }
          }
     }

     /* If errors present or no input file specified */
     if (data.er || !data.inf)
     {
          fprintf(stderr,"\nUsage: %s -i <input_file_name>",argv[0]);
          fprintf(stderr," [-w 10 bits to 16 (default is 8)]\n");
          fprintf(stderr,"       [-o <output_file_prefix>] ");
          fprintf(stderr,"[-c channels to extract (MAX 10 sets] [-h(elp)]\n");
          exit(1);
     }

     for(i = 0; i<data.ch; i++)
     {
          fprintf(stderr,"       *Opening file %s\n",data.raw_n[i]);
          fprintf(stderr,"       *channels %d %d %d %d %d\n",data.raw_i[i][0],
           data.raw_i[i][1],data.raw_i[i][2],data.raw_i[i][3],data.raw_i[i][4]);
     }

     gen_raw(&data);
     fclose(data.oneb_f);
     for(i = 0; i<data.ch; i++)
          fclose(data.raw_f[i]);
}
