/*****************************************************************/
/*
/* filtp.c copyright (c) 1994 Clemson University, all rights reserved.
/*
/* FILTP.C - Filter PRT 
/*     Compute 10 Sample Ave. Prt Values
/*     Also Filter Bad Prt Data Using 2 Standard Deviations
/*
/*
/*
/*
/*
/* $Log: filtp.c,v $
 * Revision 1.1  1995/02/28  17:12:54  rheil
 * Initial revision
 *
/*  11/01/94 - c code Modification, Robert M. Heil (Bob)
/*  01/10/95 - Support SPARC as well as ALPHA, can run multiple processors.
/*
/******************************************************************/
/* UNIX INCLUDE FILES */
#include <stdio.h>
 
/* CREATE_1B INCLUDE FILES */
#include "macros.h"
#include "types.h"
#include "hrpt.h"

/* GLOBAL VARIABLES */
static char filtp_c[] = "$Header: /projects/level1b/create.1bl/C/RCS/filtp.c,v 1.1 1995/02/28 17:12:54 rheil Exp $";

/* FUNCTIONS */
/* void filtp(runrec, rmc)
/******************************************************************/

void filtp(rundata, cal)
runrec      *rundata;
rmc         *cal;
{
    /* Builtin functions */
    flt8 sqrt();

    /* Local variables */
    flt4 var_prt[4], stdv_prt[4], error[10], temp, vtemp, t[4], ave[4];
    int4  i, k, channel, num[4];

    /* Compute 10 Sample Average */

    for (channel=1; channel<5; channel++) 
    {
        temp = 0;
        for (i=0;i<10;i++) 
            temp += rundata->prt[channel][i];
        ave[channel-1] = temp / (10);
    }

    /* Compute Variance  & Standard Deviation */
    for (k=0; k<4; k++) 
    {
        temp = 0;
        for (i=0;i<10;i++) 
            temp += (ave[k] - rundata->prt[k+1][i]) *
                    (ave[k] - rundata->prt[k+1][i]);
        var_prt[k] = temp / (10);
        stdv_prt[k] = sqrt(var_prt[k]);
    }

    /* Recompute Averages only on Points Lying Inside Of 2 Standard Deviations*/
    for (k=0; k<4; k++) 
    {
        temp = num[k] = 0;
        for (i=0;i<10;i++) 
        {
            error[i] = ave[k] - rundata->prt[k+1][i];
            if (error[i] < 0) error[i] *= -1;
            /* Original VAX code had worng variable here resulting in zero */
            if (rundata->v_flag) vtemp = 2*stdv_prt[k];
            else vtemp = 0;
            if (error[i] <= vtemp)
            { 
               temp += rundata->prt[k+1][i];
               num[k] += 1;
            } 
        }
        if (num[k] > 0)
           ave[k] = temp / num[k];
        /* Replace Prt Stack values outside 2*stdv with Recomputed Mean */
        for (i=0;i<10;i++) 
            if (error[i] > vtemp)
               rundata->prt[k+1][i] = ave[k];
    }
    for (i=0;i<4;i++)
        t[i] = cal->a0[i] + cal->a1[i] * ave[i] + cal->a2[i] * ave[i]*ave[i] +
               cal->a3[i] * ave[i] * ave[i] * ave[i] +
               cal->a4[i] * ave[i] * ave[i] * ave[i] * ave[i];
    rundata->tempave = t[0] * cal->b[0] + t[1] * cal->b[1] +
                       t[2] * cal->b[2] + t[3] * cal->b[3];
} 

