
#ifndef HRPT_H
#define HRPT_H

/*****************************************************************/
/*
/* hrpt.h copyright (c) 1995 Clemson University, all rights reserved.
/*
/* HRPT.H - Header file that defines hrpt data structures
/*
/* $Log: hrpt.h,v $
 * Revision 1.2  1995/03/10  16:24:37  rheil
 * Added header and made compile-time flags consistent
 * /
 *
/*
/******************************************************************/

/* GLOBAL VARIABLES */
static char hrpt_h[] = "$Header: /projects/level1b/create.1bl/C/RCS/hrpt.h,v 1.2 1995/03/10 16:24:37 rheil Exp $";

#include "types.h"

typedef struct hrpt_header
{
	int1	file_tyle[4];
	byte	filler1[4];
	int4	program_year;
	int4	program_month;
	int4	program_day;
	int4	program_second;
	byte	filler2[12];
	int4	sector_length;
	byte	filler3[44];
	int4	sector_offset;
	byte	filler4[44];
	int4	scan_length;
	int4	IR_image_len;
	int4	VI_inage_len;
	byte	filler5[52];
	int4	spacecraft_id;
	int4	orbital_node;
	byte	filler6[32];
	int4	pass_year;
	int4	DCS_year;
	int4	DCS_day;
	flt4	DCS_second;
	int4	epoch_year;
	int4	epoch_month;
	int4	epoch_day;
	int4	epoch_hour;
	int4	epoch_minute;
	flt4	epoch_second;
	flt4	semi_major_axis;
	flt4	eccentricity;
	flt4	inclination;
	flt4	ascenting_node_angle;
	flt4	angle_of_perigee;
	flt4	mean_anomally;
	int4	orbit_number;
	byte	filler7[208];
	} hrpt_header;

typedef struct hrpt_scanline
{
     int2 pn_count;
     int2 error_count;
     int2 status;
     int2 sync[6];
     struct doc
     {
          int2 id[2];
          int2 time[4];
          struct
          {
               int2 ch[5];	/* one per channel 1-5 */
          } ramp;
          int2 telemetry[5];
          struct
          {
               int2 ch[3];	/* one per channel 3-5 */
          } internal[10];
          struct
          {
               int2 ch[5];	/* one per channel 1-5 */
          } space[10];
          int2 sync;
     } doc;
     int2 tip[520];
     int2 spare[127];
     int2 video[10240];
     int2 filler[15];
     } hrpt_scanline;

#endif
